use std::io::Write;

fn main() -> std::io::Result<()> {
    let file = std::fs::OpenOptions::new()
        .write(true)
        .create(true)
        .open("all_chars.txt")?;

    let mut writer = std::io::BufWriter::new(file);

    for i in 0x0..(0x10FFFF + 1) {
        match char::from_u32(i) {
            Some(ch) => {
                if ch.is_control() {
                    continue;
                }
                if let Some(name) = charname::get_name_checked(i) {
                    write!(writer, "U+{:04X}\t{}\t{}\n", i, ch, name)?;
                }
            }
            None => {
                continue;
            }
        };
    }

    Ok(())
}
